package main

import (
	"log"
	"time"

	"github.com/streadway/amqp"

	"go-rest-api/src/queue"
)

// TestWorkerFunc
func main() {
	amqp := queue.New()
	exchangeName := "messages"
	if err := amqp.DeclareExchange(exchangeName, "fanout"); err != nil {
		log.Printf("Error creating `%s` exchange\n", exchangeName)
	}
	q := amqp.DeclareTMPQueue()
	if err := amqp.BindQueue(q.Name, exchangeName); err != nil {
		log.Printf("Error binding `%s` with `%s`\n", q.Name, exchangeName)
	}
	amqp.Consume(q.Name, callback)
}

func callback(d amqp.Delivery) {
	time.Sleep(5 * time.Second)
	log.Println("Received message: ", string(d.Body))
	// log.Println("Finished!")
	d.Ack(false) // IMPORTANT !
}
